# -*- coding: utf-8 -*- 
import wx
import wx.propgrid as wxpg

from DePyTranslation import *
from DePyPropGrid import ObjectPG, ListLengthPropManager
from DePyClassPopup import ClassCardDialog

# create a window ==============================================================
L = 600
w = window(width=1.6*L+0.5*window.dwidth, height=L+window.menuheight,
           title='Python 2.7.9    VPython 6.11    DePy',
           style= wx.CAPTION | wx.CLOSE_BOX | wx.MINIMIZE_BOX)

# place a 3D DISPLAY widget in the left half of the window =====================
padding = 10
fenster = Fenster(window=w, x=padding, y=padding, width=L-2*padding,
                  height=L-2*padding)

# settings for controls ========================================================
fontSmall = wx.SystemSettings_GetFont(wx.SYS_SYSTEM_FONT)
fontSmall.SetPointSize(9)
fontBig = wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD)

# place WIDGETS in the right half of the window ================================
panel = wx.Panel(w.panel, pos=(L,0), size=(0.6*L,L))
mainSizer = wx.BoxSizer(wx.VERTICAL)

objectCaption = wx.StaticText(panel, label='Objektkarte')
objectCaption.SetFont(fontBig)
mainSizer.Add(objectCaption, 0, wx.CENTER |  wx.TOP | wx.BOTTOM, border=padding)

pg = ObjectPG(panel) 
mainSizer.Add(pg, 1, wx.ALL | wx.EXPAND, border=0)

hbox = wx.BoxSizer(wx.HORIZONTAL)

btnShowAll = wx.Button(panel, label=u'zurück zur Übersicht')
btnShowAll.Bind(wx.EVT_BUTTON, lambda event: ShowWorld())

def ShowClassPopup(event):
    ccd = ClassCardDialog(None)
    ccd.ShowModal()
    ccd.Destroy()
    
btnShowClass = wx.Button(panel, label=u'Klassenkarten anzeigen')
btnShowClass.Bind(wx.EVT_BUTTON, ShowClassPopup)

hbox.Add(btnShowAll, 0, wx.ALIGN_LEFT | wx.RIGHT)
hbox.Add(btnShowClass, 0, wx.ALIGN_LEFT | wx.LEFT, border=100)
mainSizer.Add(hbox, 0)
mainSizer.Add((1, padding))

# interactive layout ===========================================================
def updateLabels(newObj):
    if not newObj:
        objectCaption.SetLabel(u'Übersicht')
        btnShowAll.Hide()
    else:
        btnShowAll.Show()
        if newObj.__class__ is Gruppe :
            objectCaption.SetLabel(u'Gruppenkarte')
        else:
            objectCaption.SetLabel(u'Objektkarte')
pg.OnObjectChange = updateLabels

# finalize layout ==============================================================
panel.SetSizer(mainSizer)
panel.Layout()        

# main loop ====================================================================
def ShowWorld():
    if pg.obj is None: return # already showing the world
    pg.CleanUpdate(None)
    pg.AppendObjectList('Vorhandene Gruppen', Gruppe.instances)
    pg.AppendObjectList('Vorhandene Objekte', Koerper.instances)
    # disp.objects contains only visible objects

def objekteAnzeigen():
    targetFps = 100
    dt = 1.0/targetFps
    ShowWorld()
    while True :
        rate(targetFps)
        if fenster.mouse.events :
            maus = fenster.mouse.getevent()
            for obj in fenster.objects :
                if maus.pick == obj :
                    try :
                        if obj is not pg.GetObject() and obj is not None:
                            pg.SetObject(obj)
                            
                    except :
                        import traceback
                        traceback.print_exc()
                        print 'FEHLER!'

                    # stop the for loop
                    break

# START WITHOUT STARTER CLASS / WITH DEFAULT VALUES ============================
if __name__ == '__main__':

    e = Quader()
    e.farbe = Farben.gelb
    e.position = (1,0,0)
    e.name = u'Gelber Würfel'    

    # start main loop:
    objekteAnzeigen()
