# -*- coding: utf-8 -*-
from visual import * 

class Daten(object):
    def setzeName(self, value):
        self.name = value
    def holeName(self):
        return self.name
##  name = property(holeName, setzeName)

    def setzePosition(self, value): # default value = (0,0,0)
        self.pos = value
    def holePosition(self):
        return self.pos
    position = property(holePosition, setzePosition)

    def setzeAchse(self, value): # default value = (1,0,0)
        self.axis = value
    def holeAchse(self):
        return self.axis
    achse = property(holeAchse, setzeAchse)

    def setzeSichtbar(self,value): #True or False
        self.visible = value
    def holeSichtbar(self):
        return self.visible
    sichtbar = property(holeSichtbar, setzeSichtbar)

    def verschieben(self, x, y, z):
        self.x += x
        self.y += y
        self.z += z

    def drehen(self,grad,drehAchse,drehUrsprung):
        self.rotate(angle=radians(grad),axis=drehAchse,origin=drehUrsprung)

class Koerper(Daten):
    count = 0
    instances = set()
    def __init__(self):
        name = 'koerper{}'.format(Koerper.count)
        Koerper.count += 1
        self.setzeName(name)
        Koerper.instances.add(self)

    def setzeFarbe(self, value): # default value = (1,1,1)
        (r,g,b) = value
        if r > 1 or g > 1 or b > 1:
            value = (r/255.0,g/255.0,b/255.0)
        self.color = value
    def holeFarbe(self):
        return self.color
    farbe = property(holeFarbe, setzeFarbe)

    def setzeMaterial(self, value): 
        self.material = value
    def holeMaterial(self):
        return self.material
    material = property(holeMaterial, setzeMaterial)

    def setzeDeckkraft(self, value):
        # workaround, since an invisible object might be displayed nevertheless
        vis = self.sichtbar
        self.sichtbar = False
        self.opacity = value
        self.sichtbar = vis
    def holeDeckkraft(self):
        return self.opacity
    deckkraft = property(holeDeckkraft, setzeDeckkraft)

    def setzeZuGruppe(self, value):
        # workaround, since otherwise the whole group becomes invisible
        vis = self.sichtbar 
        self.sichtbar = True
        self.frame = value
        self.sichtbar = vis
        value._append(self)
    def holeZuGruppe(self):
        return self.frame
    gruppe = property(holeZuGruppe,setzeZuGruppe)

    
    
# ==============================================================================
class Pfeil(arrow, Koerper):
    def __init__(self):
        arrow.__init__(self)
        Koerper.__init__(self)

    def setzeLaengePfeil(self, value):
        self.length = value
    def holeLaengePfeil(self):
        return self.length
    laengePfeil = property(holeLaengePfeil, setzeLaengePfeil)

    def setzeBreitePfeil(self, value): # default value = 0.1*length
        self.shaftwidth = value
    def holeBreitePfeil(self):
        return self.shaftwidth
    breitePfeil = property(holeBreitePfeil, setzeBreitePfeil)

    def setzeBreiteSpitze(self, value): # default value = 2*shaftwidth
        self.headwidth = value
    def holeBreiteSpitze(self):
        return self.headwidth
    breiteSpitze = property(holeBreiteSpitze, setzeBreiteSpitze)

    def setzeLaengeSpitze(self, value): # default value = 3*shaftwidth
        self.headlength = value
    def holeLaengeSpitze(self):
        return self.headlength
    laengeSpitze = property(holeLaengeSpitze, setzeLaengeSpitze)

# ==============================================================================
class Quader(box, Koerper): 
    def __init__(self):
        box.__init__(self)
        Koerper.__init__(self)

    def setzeLaenge(self, value): 
        self.length = value
    def holeLaenge(self):
        return self.length
    laenge = property(holeLaenge, setzeLaenge)
    
    def setzeBreite(self, value): 
        self.width = value
    def holeBreite(self):
        return self.width
    breite = property(holeBreite, setzeBreite)

    def setzeHoehe(self, value): 
        self.height = value
    def holeHoehe(self):
        return self.height
    hoehe = property(holeHoehe, setzeHoehe)

# ==============================================================================
class Kegel(cone, Koerper):
    def __init__(self):
        cone.__init__(self)
        Koerper.__init__(self)

    def setzeLaenge(self, value):
        self.length = value
    def holeLaenge(self):
        return self.length
    laenge = property(holeLaenge, setzeLaenge)

    def setzeRadius(self, value):
        self.radius = value
    def holeRadius(self):
        return self.radius
##  radius = property(holeRadius, setzeRadius)
    
# ==============================================================================
class Zylinder(cylinder, Koerper):
    def __init__(self):
        cylinder.__init__(self)
        Koerper.__init__(self)

    def setzeLaenge(self, value):
        self.length = value
    def holeLaenge(self):
        return self.length
    laenge = property(holeLaenge, setzeLaenge)

    def setzeRadius(self, value):
        self.radius = value
    def holeRadius(self):
        return self.radius
##  radius = property(holeRadius, setzeRadius)

# ==============================================================================
class Ellipsoid(ellipsoid, Koerper):
    def __init__(self):
        ellipsoid.__init__(self)
        Koerper.__init__(self)

    def setzeLaenge(self, value):
        self.length = value
    def holeLaenge(self):
        return self.length
    laenge = property(holeLaenge, setzeLaenge)
    
    def setzeBreite(self, value):
        self.width = value
    def holeBreite(self):
        return self.width
    breite = property(holeBreite, setzeBreite)

    def setzeHoehe(self, value):
        self.height = value
    def holeHoehe(self):
        return self.height
    hoehe = property(holeHoehe, setzeHoehe)

# ==============================================================================
class Pyramide(pyramid, Koerper):
    def __init__(self):
        pyramid.__init__(self)
        Koerper.__init__(self)

    def setzeLaenge(self, value):
        self.length = value
    def holeLaenge(self):
        return self.length
    laenge = property(holeLaenge, setzeLaenge)
    
    def setzeBreite(self, value):
        self.width = value
    def holeBreite(self):
        return self.width
    breite = property(holeBreite, setzeBreite)

    def setzeHoehe(self, value):
        self.height = value
    def holeHoehe(self):
        return self.height
    hoehe = property(holeHoehe, setzeHoehe)

# ==============================================================================
class Ring(ring, Koerper):
    def __init__(self):
        ring.__init__(self)
        Koerper.__init__(self)

    def setzeRadius(self, value):
        self.radius = value
    def holeRadius(self):
        return self.radius
##  radius = property(holeRadius, setzeRadius)

    def setzeDicke(self, value):
        self.thickness = value
    def holeDicke(self):
        return self.thickness
    dicke = property(holeDicke, setzeDicke)

# ==============================================================================
class Kugel(sphere, Koerper):
    def __init__(self):
        sphere.__init__(self)
        Koerper.__init__(self)
        
    def setzeRadius(self, value):
        self.radius = value
    def holeRadius(self):
        return self.radius
##  radius = property(holeRadius, setzeRadius)

# ==============================================================================
class Gruppe(frame, Daten):
    instances = set()

    def __init__(self, name, *objects):
        frame.__init__(self)
        self.name = name
        self.Liste = set()
        
        Gruppe.instances.add(self)

        for obj in objects:
            self.hinzufuegen(obj)

    def _append(self, obj):
        self.Liste.add(obj)

    def hinzufuegen(self, obj):
        obj.gruppe = self


# materials and colors =========================================================
class Materialien(object):
    @classmethod
    def _GetKeys(cls):
        return filter(lambda mat : not mat.startswith('_'), dir(cls))
    @classmethod
    def _GetValues(cls):
        return map(lambda mat: getattr(cls,mat), cls._GetKeys())
        
    Holz        = materials.wood
    Granit      = materials.rough
    Marmor      = materials.marble
    Plastik     = materials.plastic
    Erde        = materials.earth
    Wolkenerde  = materials.BlueMarble  # earth with clouds
    Standard    = materials.diffuse
    Leuchtend   = materials.emissive    # looks like it glows
    Schattenlos = materials.unshaded    # unaffected by lighting
    Glanz       = materials.shiny
    Chrom       = materials.chrome
    Metallic    = materials.blazed
    Glitzer     = materials.silver
    Ziegel      = materials.bricks

class Farben(object):
    schwarz = color.black   # (0,0,0)
    rot     = color.red     # (1,0,0)
    gruen   = color.green   # (0,1,0)
    blau    = color.blue    # (0,0,1)
    gelb    = color.yellow  # (1,1,0)
    magenta = color.magenta # (1,0,1)
    cyan    = color.cyan    # (0,1,1)
    weiss   = color.white   # (1,1,1)
    orange  = color.orange  # (1,0.5,0)

# display functions ============================================================
class Fenster(display):
    def __init__(self, window=None, x=0, y=0, width=430, height=450):
        display.__init__(self, window=window, x=x, y=y, width=width,
                         height=height)

    def setzeZentrum(self, value):
        self.center = value
    def holeZentrum(self):
        return self.center
    zentrum = property(holeZentrum, setzeZentrum)

    def setzeAutoZentrum(self, value):
        self.autocenter = value
    def holeAutoZentrum(self):
        return self.autocenter
    autoZentrum = property(holeAutoZentrum, setzeAutoZentrum)

    def setzeKameraRichtung(self, value):
        self.forward = value
    def holeKameraRichtung(self):
        return self.forward
    kameraRichtung = property(holeKameraRichtung, setzeKameraRichtung)

    def setzeKameraWinkel(self, value):
        self.fov = value
    def holeKameraWinkel(self):
        return self.fov
    kameraWinkel = property(holeKameraWinkel, setzeKameraWinkel)

    def setzeRegion(self, value):
        self.range = value
    def holeRegion(self):
        return self.range
    region = property(holeRegion, setzeRegion)

    def setzeZoom(self, value):
        self.scale = value
    def holeZoom(self):
        return self.scale
    zoom = property(holeZoom, setzeZoom)

    def setzeAuf(self, value):
        self.up = value
    def holeAuf(self):
        return self.center
    auf = property(holeAuf, setzeAuf)

    def setzeAutoZoom(self, value):
        self.autoscale = value
    def holeAutoZoom(self):
        return self.autoscale
    autoZoom = property(holeAutoZoom, setzeAutoZoom)

    def setzeBenutzerZoom(self, value):
        self.userzoom = value
    def holeBenutzerZoom(self):
        return self.userzoom
    benutzerZoom = property(holeBenutzerZoom, setzeBenutzerZoom)

    def setzeBenutzerRotation(self, value):
        self.userspin = value
    def holeBenutzerRotation(self):
        return self.userspin
    benutzerRotation = property(holeBenutzerRotation, setzeBenutzerRotation)

    def setzeVordergrundfarbe(self,value):
        self.foreground = value
    def holeVordergrundfarbe(self):
        return self.foreground
    vordergrundfarbe = property(holeVordergrundfarbe, setzeVordergrundfarbe)

    def setzeHintergrundfarbe(self,value):
        self.background = value
    def holeHintergrundfarbe(self):
        return self.background
    hintergrundfarbe = property(holeHintergrundfarbe, setzeHintergrundfarbe)

    def setzeDreiDBrille(self,value):
        self.stereo = value
    def holeDreiDBrille(self):
        return self.stereo
    dreiDBrille = property(holeDreiDBrille, setzeDreiDBrille)

    #Folgende FensterAttribute auf Deutsch sind nur ohne die GUI sinnvoll:
    
    def setzeTitel(self,value):
        self.title = value
    def holeTitel(self):
        return self.title
    titel = property(holeTitel, setzeTitel)

    def setzeBreite(self,value):
        self.width = value
    def holeBreite(self):
        return self.width
    breite = property(holeBreite, setzeBreite)

    def setzeHoehe(self,value):
        self.height = value
    def holeHoehe(self):
        return self.height
    hoehe = property(holeHoehe, setzeHoehe)

    def setzeVollbild(self,value):
        self.fullscreen = value
    def holeVollbild(self):
        return self.fullscreen
    vollbild = property(holeVollbild, setzeVollbild)

    

# basic functions ==============================================================
Wahr = True
Falsch = False

def schreibe(x): print x
